
/* Chrysalide - Outil d'analyse de fichiers binaires
 * thread.h - prototypes pour les interactions avec les différents threads
 *
 * Copyright (C) 2012-2017 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Chrysalide.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _DEBUG_JDWP_SETS_THREAD_H
#define _DEBUG_JDWP_SETS_THREAD_H


#include <stdbool.h>


#include "../jdwp_def.h"
#include "../../../arch/archbase.h"


/* Prépare une requête demandant le nom d'un thread. */
bool set_jdwp_thread_name(const jdwp_cmd_thread_name_request *, const jdwp_cmd_vm_id_sizes_reply *, bin_t *, off_t *);

/* Reconstitue une réponse fournissant le nom d'un thread. */
bool get_jdwp_thread_name(const bin_t *, off_t, const jdwp_cmd_vm_id_sizes_reply *, jdwp_cmd_thread_name_reply *);

/* Libère le nom donné à un thread. */
void free_jdwp_thread_name_reply(jdwp_cmd_thread_name_reply *);

/* Prépare une requête demandant les frames d'un thread. */
bool set_jdwp_thread_frames(const jdwp_cmd_thread_frames_request *, const jdwp_cmd_vm_id_sizes_reply *, bin_t *, off_t *);

/* Reconstitue une réponse fournissant les frames d'un thread. */
bool get_jdwp_thread_frames(const bin_t *, off_t, const jdwp_cmd_vm_id_sizes_reply *, jdwp_cmd_thread_frames_reply *);

/* Libère une liste de frames d'un thread. */
void free_jdwp_thread_frames_reply(jdwp_cmd_thread_frames_reply *);



#endif  /* _DEBUG_JDWP_SETS_THREAD_H */
